jif.lang

## Class PairLabel

- java.lang.Object
- - jif.lang.PairLabel

- All Implemented Interfaces:
    Label

      public final class PairLabel
      extends java.lang.Object
      implements Label

  A Label is the runtime representation of a Jif label. A Label consists of a set of components, each of which is a `Policy`.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `PairLabel(LabelUtil labelUtil, ConfPolicy confPol, IntegPolicy integPol)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ConfPolicy` | `confPolicy()`
    `boolean` | `equals(java.lang.Object o)`
    `int` | `hashCode()`
    `IntegPolicy` | `integPolicy()`
    `Label` | `join(Label l)`
    `Label` | `join(Label l, boolean simplify)`
    `Label` | `meet(Label l)`
    `Label` | `meet(Label l, boolean simplify)`
    `boolean` | `relabelsTo(Label l, java.util.Set<jif.lang.PrincipalUtil.DelegationPair> s)` Returns true iff this <= l.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### PairLabel

          public PairLabel(LabelUtil labelUtil,
                           ConfPolicy confPol,
                           IntegPolicy integPol)

  - ### Method Detail

    - #### relabelsTo

          public boolean relabelsTo(Label l,
                                    java.util.Set<jif.lang.PrincipalUtil.DelegationPair> s)

      Description copied from interface: `Label`
      Returns true iff this <= l. If the method returns true, then s has all of the delegations (i.e., DelegationPairs) added to it that the result depends upon. If the method returns false, then s has no elements added to it.
      Specified by:
        `relabelsTo` in interface `Label`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### equals

          public boolean equals(java.lang.Object o)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### toString

          public final java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### join

          public final Label join(Label l)

      Specified by:
        `join` in interface `Label`

    - #### join

          public final Label join(Label l,
                                  boolean simplify)

      Specified by:
        `join` in interface `Label`

    - #### meet

          public Label meet(Label l)

      Specified by:
        `meet` in interface `Label`

    - #### meet

          public Label meet(Label l,
                            boolean simplify)

      Specified by:
        `meet` in interface `Label`

    - #### confPolicy

          public ConfPolicy confPolicy()

      Specified by:
        `confPolicy` in interface `Label`

    - #### integPolicy

          public IntegPolicy integPolicy()

      Specified by:
        `integPolicy` in interface `Label`